image: docker:18.09.7

stages:
  - build_develop
  - build_release
  - build_stage
  - build_prod
  - deploy_develop
  - deploy_release
services: 
  - docker:18.09.7-dind
  
# NON EXECUTABLE BUILD TEMPLATE #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
.execute_build_lifecycle: &execute_build_lifecycle
  stage: build
  variables:
    DCR_ENV_REPO: $CI_COMMIT_REF_NAME
    IMAGE_TAG: latest
    DOCKER_HOST: tcp://localhost:2375
  before_script:
    - echo $WP_IMAGE_REF
    - |
      if [ -z "$WP_IMAGE_REF" ]; then
        export WP_IMAGE_REF=$REGISTRY/$GROUP/$DCR_ENV_REPO/$WP_IMAGE:latest;
      fi;
    - echo $DOCKER_PASSWORD > ~/login_pass.txt
  script:
    - cat ~/login_pass.txt | docker login -u $DOCKER_USER --password-stdin https://$REGISTRY
    - | 
      docker build \
      --build-arg WORDPRESS_IMAGE=$WP_IMAGE_REF \
      --build-arg ENV=$PREFIX \
      --build-arg ENV_USER=$ENV_USER \
      --build-arg ENV_PASSWORD=$ENV_PASSWORD \
      --tag $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:$IMAGE_TAG .
    - docker push $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:$IMAGE_TAG
    - | 
      if [ "$CI_COMMIT_REF_NAME" == "master" ]; then
        docker build \
        --build-arg WORDPRESS_IMAGE=$WP_IMAGE_REF \
        --build-arg ENV=$ENV \
        --build-arg ENV_USER=$ENV_USER \
        --build-arg ENV_PASSWORD=$ENV_PASSWORD \
        --tag $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:latest .
        docker push $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:latest
      fi
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #


build_develop: 
  <<: *execute_build_lifecycle
  stage: build_develop
  variables:
    DCR_ENV_REPO: $CI_COMMIT_REF_NAME
    IMAGE_TAG: latest
    DOCKER_HOST: tcp://localhost:2375
    PREFIX: develop
  only:
    - develop

build_release: 
  <<: *execute_build_lifecycle
  stage: build_release
  variables:
    DCR_ENV_REPO: $CI_COMMIT_REF_NAME
    IMAGE_TAG: latest
    DOCKER_HOST: tcp://localhost:2375
    PREFIX: release
  only:
    refs:
      - /^release\/v.*$/
    variables:
      - $TARGET_RELEASE_BRANCH == $CI_COMMIT_REF_NAME


build_stage: 
  <<: *execute_build_lifecycle
  stage: build_stage
  variables:
    DCR_ENV_REPO: stage
    IMAGE_TAG: $CI_COMMIT_SHORT_SHA
    DOCKER_HOST: tcp://localhost:2375
    PREFIX: stage
  only:
    refs:
      - master
    variables:
      - $ENV == "stage"

build_prod: 
  <<: *execute_build_lifecycle
  stage: build_prod
  variables:
    DCR_ENV_REPO: prod
    IMAGE_TAG: $CI_COMMIT_SHORT_SHA
    DOCKER_HOST: tcp://localhost:2375
    PREFIX: prod
  only:
    refs:
      - master
    variables:
      - $ENV == "prod"

deploy_develop: 
  stage: deploy_develop
  script:
    - apk add --no-cache curl
    - | 
      curl -X POST \
      -F token=$CI_JOB_TOKEN \
      -F ref=master \
      -F "variables[SERVICE]=nginx" \
      -F "variables[ENV]=$CI_COMMIT_REF_NAME" \
      https://gitlab.linnovate.net/api/v4/projects/880/trigger/pipeline
  only: 
    - develop

deploy_release: 
  stage: deploy_release
  script:
    - apk add --no-cache curl
    - | 
      curl -X POST \
      -F token=$CI_JOB_TOKEN \
      -F ref=master \
      -F "variables[SERVICE]=nginx" \
      -F "variables[ENV]=$CI_COMMIT_REF_NAME" \
      https://gitlab.linnovate.net/api/v4/projects/880/trigger/pipeline
  only:
    refs:
      - /^release\/v.*$/
    variables:
      - $TARGET_RELEASE_BRANCH == $CI_COMMIT_REF_NAME
